/**
 * \file
 *
 * \brief Header file for sam3n.h
 *
 * Copyright (c) 2015 Atmel Corporation. All rights reserved.
 *
 * \asf_license_start
 *
 * \page License
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. The name of Atmel may not be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. This software may only be redistributed and used in connection with an
 *    Atmel microcontroller product.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM3N_
#define _SAM3N_

#if defined (__SAM3N4C__)
#include "sam3n4c.h"
#elif defined (__SAM3N4B__)
#include "sam3n4b.h"
#elif defined (__SAM3N4A__)
#include "sam3n4a.h"
#elif defined (__SAM3N2C__)
#include "sam3n2c.h"
#elif defined (__SAM3N2B__)
#include "sam3n2b.h"
#elif defined (__SAM3N2A__)
#include "sam3n2a.h"
#elif defined (__SAM3N1C__)
#include "sam3n1c.h"
#elif defined (__SAM3N1B__)
#include "sam3n1b.h"
#elif defined (__SAM3N1A__)
#include "sam3n1a.h"
#elif defined (__SAM3N0C__)
#include "sam3n0c.h"
#elif defined (__SAM3N0B__)
#include "sam3n0b.h"
#elif defined (__SAM3N0A__)
#include "sam3n0a.h"
#elif defined (__SAM3N00B__)
#include "sam3n00b.h"
#elif defined (__SAM3N00A__)
#include "sam3n00a.h"
#else
  #error Library does not support the specified device.
#endif

#endif /* _SAM3N_ */
